<?php
function imageCreateFromAny($filepath)
	{
	$type = exif_imagetype($filepath);
	$allowedTypes = array(
        1, // gif
        2, // jpg
        3, // png
	);
	if (!in_array($type, $allowedTypes))
		{return false;}
	switch ($type)
		{
		case 1 :$im = imageCreateFromGif($filepath);
		break;
		case 2 :$im = imageCreateFromJpeg($filepath);
		break;
		case 3 :$im = imageCreateFromPng($filepath);
		break;
		}   
	return $im; 
	} 

function image_get($file,$fromstring=FALSE)
	{
	if($fromstring===TRUE)
		{return @imagecreatefromstring(file_get_contents($file));}
	else
		{return imageCreateFromAny($file);}
	}

function image_crop($image,$thumb_width = 192,$thumb_height = 120)
	{
	$width = imagesx($image);
	$height = imagesy($image);
	$original_aspect = $width / $height;
	$thumb_aspect = $thumb_width / $thumb_height;
	if ( $original_aspect >= $thumb_aspect )
		{
		$new_height = $thumb_height;
		$new_width = $width / ($height / $thumb_height);
		}
	else
		{
		$new_width = $thumb_width;
		$new_height = $height / ($width / $thumb_width);
		}
	$thumb = imagecreatetruecolor( $thumb_width, $thumb_height );
	imagecopyresampled($thumb,
                   $image,
                   0 - ($new_width - $thumb_width) / 2, 
                   0 - ($new_height - $thumb_height) / 2,
                   0, 0,
                   $new_width, $new_height,
                   $width, $height);
	return $thumb;
	}

function image_output($image,$type="jpeg",$destination=NULL,$quality=60)
	{
	ob_start();
	switch ($type) 
		{
		case "gif":
			ImageGif($image,$destination);
		break;

		case "png":
			$pngQuality = ($quality - 100) / 11.111111;
			$pngQuality = round(abs($pngQuality));
			ImagePng($image,$destination,$pngQuality);
		break;

		case "jpeg":
		case "jpg" :
			ImageJpeg($image,$destination,$quality);
		break;
    		}
	$img=ob_get_clean();
	imagedestroy($image);
	header("Content-Type: image/$type");
	if(!empty($destination))
		{readfile($destination);}
	else
		{
		header('Content-Length: '.strlen($img));
		print $img;
		}
	exit;
	}


$file	= (!empty($_REQUEST['file'])) ? $_REQUEST['file']: FALSE;
$width	= (!empty($_REQUEST['width'])) ? $_REQUEST['width']: 240;
$height	= (!empty($_REQUEST['height'])) ? $_REQUEST['height']: 160;

if(file_exists($file))
	{
	$img = image_get($file);
	$img = image_crop($img,$width ,$height);
	image_output($img,$type="jpeg",$destination,$quality=85);
	}
?>
